FLTK: Fl_Browser Class Reference

FLTK

Public Types | Public Member Functions | Protected Member Functions | List of all members
Fl_Browser Class Reference

The Fl_Browser widget displays a scrolling list of text lines, and manages all the storage for the text. More...

`#include <Fl_Browser.H>`

Inheritance diagram for Fl_Browser:

## Public Types
enum | Fl_Line_Position { TOP, BOTTOM, MIDDLE }
| For internal use only?
Public Types inherited from Fl_Browser_
enum | { HORIZONTAL = 1, VERTICAL = 2, BOTH = 3, ALWAYS_ON = 4, HORIZONTAL_ALWAYS = 5, VERTICAL_ALWAYS = 6, BOTH_ALWAYS = 7 }
| Values for has_scrollbar(). More...

## Public Member Functions
void | add (const char *newtext, void *d=0)
| Adds a new line to the end of the browser. More...
void | bottomline (int line)
| Scrolls the browser so the bottom item in the browser is showing the specified `line`. More...
void | clear ()
| Removes all the lines in the browser. More...
char | column_char () const
| Gets the current column separator character. More...
void | column_char (char c)
| Sets the column separator to c. More...
const int * | column_widths () const
| Gets the current column width array. More...
void | column_widths (const int *arr)
| Sets the current array to `arr`. More...
void * | data (int line) const
| Returns the user data() for specified `line`. More...
void | data (int line, void *d)
| Sets the user data for specified `line` to `d`. More...
void | display (int line, int val=1)
| For back compatibility. More...
int | displayed (int line) const
| Returns non-zero if `line` has been scrolled to a position where it is being displayed. More...
| Fl_Browser (int X, int Y, int W, int H, const char *L=0)
| The constructor makes an empty browser. More...
char | format_char () const
| Gets the current format code prefix character, which by default is '@'. More...
void | format_char (char c)
| Sets the current format code prefix character to `c`. More...
void | hide ()
| Hides the entire Fl_Browser widget – opposite of show().
void | hide (int line)
| Makes `line` invisible, preventing selection by the user. More...
Fl_Image * | icon (int line) const
| Returns the icon currently defined for `line`. More...
void | icon (int line, Fl_Image *icon)
| Set the image icon for `line` to the value `icon`. More...
void | insert (int line, const char *newtext, void *d=0)
| Insert a new entry whose label is `newtext` above given `line`, optional data `d`. More...
void | lineposition (int line, Fl_Line_Position pos)
| Updates the browser so that `line` is shown at position `pos`. More...
int | load (const char *filename)
| Clears the browser and reads the file, adding each line from the file to the browser. More...
void | make_visible (int line)
| Make the item at the specified `line` visible(). More...
void | middleline (int line)
| Scrolls the browser so the middle item in the browser is showing the specified `line`. More...
void | move (int to, int from)
| Line `from` is removed and reinserted at `to`. More...
void | remove (int line)
| Remove entry for given `line` number, making the browser one line shorter. More...
void | remove_icon (int line)
| Removes the icon for `line`. More...
void | replace (int a, const char *b)
| For back compatibility only.
int | select (int line, int val=1)
| Sets the selection state of the item at `line` to the value `val`. More...
int | selected (int line) const
| Returns 1 if specified `line` is selected, 0 if not. More...
void | show ()
| Shows the entire Fl_Browser widget – opposite of hide().
void | show (int line)
| Makes `line` visible, and available for selection by user. More...
int | size () const
| Returns how many lines are in the browser. More...
void | size (int W, int H)
void | swap (int a, int b)
| Swaps two browser lines `a` and `b`. More...
const char * | text (int line) const
| Returns the label text for the specified `line`. More...
void | text (int line, const char *newtext)
| Sets the text for the specified `line` to `newtext`. More...
Fl_Fontsize | textsize () const
| Gets the default text size (in pixels) for the lines in the browser.
void | textsize (Fl_Fontsize newSize)
| Sets the default text size (in pixels) for the lines in the browser to `newSize`. More...
int | topline () const
| Returns the line that is currently visible at the top of the browser. More...
void | topline (int line)
| Scrolls the browser so the top item in the browser is showing the specified `line`. More...
int | value () const
| Returns the line number of the currently selected line, or 0 if none selected. More...
void | value (int line)
| Sets the browser's value(), which selects the specified `line`. More...
int | visible (int line) const
| Returns non-zero if the specified `line` is visible, 0 if hidden. More...
| ~Fl_Browser ()
| The destructor deletes all list items and destroys the browser.
Public Member Functions inherited from Fl_Browser_
int | deselect (int docallbacks=0)
| Deselects all items in the list and returns 1 if the state changed or 0 if it did not. More...
void | display (void *item)
| Displays the `item`, scrolling the list as necessary. More...
int | handle (int event)
| Handles the `event` within the normal widget bounding box. More...
uchar | has_scrollbar () const
| Returns the current scrollbar mode, see Fl_Browser_::has_scrollbar(uchar)
void | has_scrollbar (uchar mode)
| Sets whether the widget should have scrollbars or not (default Fl_Browser_::BOTH). More...
int | hposition () const
| Gets the horizontal scroll position of the list as a pixel position `pos`. More...
void | hposition (int)
| Sets the horizontal scroll position of the list to pixel position `pos`. More...
int | position () const
| Gets the vertical scroll position of the list as a pixel position `pos`. More...
void | position (int pos)
| Sets the vertical scroll position of the list to pixel position `pos`. More...
void | resize (int X, int Y, int W, int H)
| Repositions and/or resizes the browser. More...
void | scrollbar_left ()
| Moves the vertical scrollbar to the lefthand side of the list. More...
void | scrollbar_right ()
| Moves the vertical scrollbar to the righthand side of the list. More...
int | scrollbar_size () const
| Gets the current size of the scrollbars' troughs, in pixels. More...
void | scrollbar_size (int newSize)
| Sets the pixel size of the scrollbars' troughs to `newSize`, in pixels. More...
int | scrollbar_width () const
| This method has been deprecated, existing for backwards compatibility only. More...
void | scrollbar_width (int width)
| This method has been deprecated, existing for backwards compatibility only. More...
int | select (void *item, int val=1, int docallbacks=0)
| Sets the selection state of `item` to `val`, and returns 1 if the state changed or 0 if it did not. More...
int | select_only (void *item, int docallbacks=0)
| Selects `item` and returns 1 if the state changed or 0 if it did not. More...
void | sort (int flags=0)
| Sort the items in the browser based on `flags`. More...
Fl_Color | textcolor () const
| Gets the default text color for the lines in the browser.
void | textcolor (Fl_Color col)
| Sets the default text color for the lines in the browser to color `col`.
Fl_Font | textfont () const
| Gets the default text font for the lines in the browser. More...
void | textfont (Fl_Font font)
| Sets the default text font for the lines in the browser to `font`.
Fl_Fontsize | textsize () const
| Gets the default text size (in pixels) for the lines in the browser.
void | textsize (Fl_Fontsize newSize)
| Sets the default text size (in pixels) for the lines in the browser to `size`.
Public Member Functions inherited from Fl_Group
Fl_Widget *& | _ddfdesign_kludge ()
| This is for forms compatibility only.
void | add (Fl_Widget &)
| The widget is removed from its current group (if any) and then added to the end of this group.
void | add (Fl_Widget *o)
| See void Fl_Group::add(Fl_Widget &w)
void | add_resizable (Fl_Widget &o)
| Adds a widget to the group and makes it the resizable widget.
Fl_Widget *const * | array () const
| Returns a pointer to the array of children. More...
virtual Fl_Group * | as_group ()
| Returns an Fl_Group pointer if this widget is an Fl_Group. More...
void | begin ()
| Sets the current group so you can build the widget tree by just constructing the widgets. More...
Fl_Widget * | child (int n) const
| Returns array()[n]. More...
int | children () const
| Returns how many child widgets the group has.
void | clear ()
| Deletes all child widgets from memory recursively. More...
unsigned int | clip_children ()
| Returns the current clipping mode. More...
void | clip_children (int c)
| Controls whether the group widget clips the drawing of child widgets to its bounding box. More...
void | end ()
| Exactly the same as current(this->parent()). More...
int | find (const Fl_Widget &o) const
| See int Fl_Group::find(const Fl_Widget *w) const.
int | find (const Fl_Widget *) const
| Searches the child array for the widget and returns the index. More...
| Fl_Group (int, int, int, int, const char *=0)
| Creates a new Fl_Group widget using the given position, size, and label string. More...
void | focus (Fl_Widget *W)
void | forms_end ()
| This is for forms compatibility only.
int | handle (int)
| Handles the specified event. More...
void | init_sizes ()
| Resets the internal array of widget sizes and positions. More...
void | insert (Fl_Widget &, int i)
| The widget is removed from its current group (if any) and then inserted into this group. More...
void | insert (Fl_Widget &o, Fl_Widget *before)
| This does insert(w, find(before)). More...
void | remove (Fl_Widget &)
| Removes a widget from the group but does not delete it. More...
void | remove (Fl_Widget *o)
| Removes the widget `o` from the group. More...
void | remove (int index)
| Removes the widget at `index` from the group but does not delete it. More...
Fl_Widget * | resizable () const
| See void Fl_Group::resizable(Fl_Widget *box)
void | resizable (Fl_Widget &o)
| See void Fl_Group::resizable(Fl_Widget *box)
void | resizable (Fl_Widget *o)
| The resizable widget defines the resizing box for the group. More...
void | resize (int, int, int, int)
| Resizes the Fl_Group widget and all of its children. More...
virtual | ~Fl_Group ()
| The destructor also deletes all the children. More...
Public Member Functions inherited from Fl_Widget
void | _clear_fullscreen ()
void | _set_fullscreen ()
void | activate ()
| Activates the widget. More...
unsigned int | active () const
| Returns whether the widget is active. More...
int | active_r () const
| Returns whether the widget and all of its parents are active. More...
Fl_Align | align () const
| Gets the label alignment. More...
void | align (Fl_Align alignment)
| Sets the label alignment. More...
long | argument () const
| Gets the current user data (long) argument that is passed to the callback function. More...
void | argument (long v)
| Sets the current user data (long) argument that is passed to the callback function. More...
virtual class Fl_Gl_Window * | as_gl_window ()
| Returns an Fl_Gl_Window pointer if this widget is an Fl_Gl_Window. More...
virtual Fl_Window * | as_window ()
| Returns an Fl_Window pointer if this widget is an Fl_Window. More...
Fl_Boxtype | box () const
| Gets the box type of the widget. More...
void | box (Fl_Boxtype new_box)
| Sets the box type for the widget. More...
Fl_Callback_p | callback () const
| Gets the current callback function for the widget. More...
void | callback (Fl_Callback *cb)
| Sets the current callback function for the widget. More...
void | callback (Fl_Callback *cb, void *p)
| Sets the current callback function for the widget. More...
void | callback (Fl_Callback0 *cb)
| Sets the current callback function for the widget. More...
void | callback (Fl_Callback1 *cb, long p=0)
| Sets the current callback function for the widget. More...
unsigned int | changed () const
| Checks if the widget value changed since the last callback. More...
void | clear_active ()
| Marks the widget as inactive without sending events or changing focus. More...
void | clear_changed ()
| Marks the value of the widget as unchanged. More...
void | clear_damage (uchar c=0)
| Clears or sets the damage flags. More...
void | clear_output ()
| Sets a widget to accept input. More...
void | clear_visible ()
| Hides the widget. More...
void | clear_visible_focus ()
| Disables keyboard focus navigation with this widget. More...
Fl_Color | color () const
| Gets the background color of the widget. More...
void | color (Fl_Color bg)
| Sets the background color of the widget. More...
void | color (Fl_Color bg, Fl_Color sel)
| Sets the background and selection color of the widget. More...
Fl_Color | color2 () const
| For back compatibility only. More...
void | color2 (unsigned a)
| For back compatibility only. More...
int | contains (const Fl_Widget *w) const
| Checks if w is a child of this widget. More...
void | copy_label (const char *new_label)
| Sets the current label. More...
void | copy_tooltip (const char *text)
| Sets the current tooltip text. More...
uchar | damage () const
| Returns non-zero if draw() needs to be called. More...
void | damage (uchar c)
| Sets the damage bits for the widget. More...
void | damage (uchar c, int x, int y, int w, int h)
| Sets the damage bits for an area inside the widget. More...
int | damage_resize (int, int, int, int)
| Internal use only.
void | deactivate ()
| Deactivates the widget. More...
Fl_Image * | deimage ()
| Gets the image that is used as part of the widget label. More...
const Fl_Image * | deimage () const
void | deimage (Fl_Image &img)
| Sets the image to use as part of the widget label. More...
void | deimage (Fl_Image *img)
| Sets the image to use as part of the widget label. More...
void | do_callback ()
| Calls the widget callback. More...
void | do_callback (Fl_Widget *o, long arg)
| Calls the widget callback. More...
void | do_callback (Fl_Widget *o, void *arg=0)
| Calls the widget callback. More...
void | draw_label (int, int, int, int, Fl_Align) const
| Draws the label in an arbitrary bounding box with an arbitrary alignment. More...
int | h () const
| Gets the widget height. More...
Fl_Image * | image ()
| Gets the image that is used as part of the widget label. More...
const Fl_Image * | image () const
void | image (Fl_Image &img)
| Sets the image to use as part of the widget label. More...
void | image (Fl_Image *img)
| Sets the image to use as part of the widget label. More...
int | inside (const Fl_Widget *wgt) const
| Checks if this widget is a child of `wgt`. More...
int | is_label_copied () const
| Returns whether the current label was assigned with copy_label(). More...
const char * | label () const
| Gets the current label text. More...
void | label (const char *text)
| Sets the current label pointer. More...
void | label (Fl_Labeltype a, const char *b)
| Shortcut to set the label text and type in one call. More...
Fl_Color | labelcolor () const
| Gets the label color. More...
void | labelcolor (Fl_Color c)
| Sets the label color. More...
Fl_Font | labelfont () const
| Gets the font to use. More...
void | labelfont (Fl_Font f)
| Sets the font to use. More...
Fl_Fontsize | labelsize () const
| Gets the font size in pixels. More...
void | labelsize (Fl_Fontsize pix)
| Sets the font size in pixels. More...
Fl_Labeltype | labeltype () const
| Gets the label type. More...
void | labeltype (Fl_Labeltype a)
| Sets the label type. More...
void | measure_label (int &ww, int &hh) const
| Sets width ww and height hh accordingly with the label size. More...
unsigned int | output () const
| Returns if a widget is used for output only. More...
Fl_Group * | parent () const
| Returns a pointer to the parent widget. More...
void | parent (Fl_Group *p)
| Internal use only - "for hacks only". More...
void | position (int X, int Y)
| Repositions the window or widget. More...
void | redraw ()
| Schedules the drawing of the widget. More...
void | redraw_label ()
| Schedules the drawing of the label. More...
Fl_Color | selection_color () const
| Gets the selection color. More...
void | selection_color (Fl_Color a)
| Sets the selection color. More...
void | set_active ()
| Marks the widget as active without sending events or changing focus. More...
void | set_changed ()
| Marks the value of the widget as changed. More...
void | set_output ()
| Sets a widget to output only. More...
void | set_visible ()
| Makes the widget visible. More...
void | set_visible_focus ()
| Enables keyboard focus navigation with this widget. More...
void | size (int W, int H)
| Changes the size of the widget. More...
int | take_focus ()
| Gives the widget the keyboard focus. More...
unsigned int | takesevents () const
| Returns if the widget is able to take events. More...
int | test_shortcut ()
| Returns true if the widget's label contains the entered '&x' shortcut. More...
const char * | tooltip () const
| Gets the current tooltip text. More...
void | tooltip (const char *text)
| Sets the current tooltip text. More...
Fl_Window * | top_window () const
| Returns a pointer to the top-level window for the widget. More...
Fl_Window * | top_window_offset (int &xoff, int &yoff) const
| Finds the x/y offset of the current widget relative to the top-level window. More...
uchar | type () const
| Gets the widget type. More...
void | type (uchar t)
| Sets the widget type. More...
int | use_accents_menu ()
| Returns non zero if MAC_USE_ACCENTS_MENU flag is set, 0 otherwise.
void * | user_data () const
| Gets the user data for this widget. More...
void | user_data (void *v)
| Sets the user data for this widget. More...
unsigned int | visible () const
| Returns whether a widget is visible. More...
unsigned int | visible_focus ()
| Checks whether this widget has a visible focus. More...
void | visible_focus (int v)
| Modifies keyboard focus navigation. More...
int | visible_r () const
| Returns whether a widget and all its parents are visible. More...
int | w () const
| Gets the widget width. More...
Fl_When | when () const
| Returns the conditions under which the callback is called. More...
void | when (uchar i)
| Sets the flags used to decide when a callback is called. More...
Fl_Window * | window () const
| Returns a pointer to the nearest parent window up the widget hierarchy. More...
int | x () const
| Gets the widget position in its window. More...
int | y () const
| Gets the widget position in its window. More...
virtual | ~Fl_Widget ()
| Destroys the widget. More...

## Protected Member Functions
FL_BLINE * | _remove (int line)
| Removes the item at the specified `line`. More...
FL_BLINE * | find_line (int line) const
| Returns the item for specified `line`. More...
int | full_height () const
| The height of the entire list of all visible() items in pixels. More...
int | incr_height () const
| The default 'average' item height (including inter-item spacing) in pixels. More...
void | insert (int line, FL_BLINE *item)
| Insert specified `item` above `line`. More...
void * | item_at (int line) const
| Return the item at specified `line`. More...
void | item_draw (void *item, int X, int Y, int W, int H) const
| Draws `item` at the position specified by `X` `Y` `W` `H`. More...
void * | item_first () const
| Returns the very first item in the list. More...
int | item_height (void *item) const
| Returns height of `item` in pixels. More...
void * | item_last () const
| Returns the very last item in the list. More...
void * | item_next (void *item) const
| Returns the next item after `item`. More...
void * | item_prev (void *item) const
| Returns the previous item before `item`. More...
void | item_select (void *item, int val)
| Change the selection state of `item` to the value `val`. More...
int | item_selected (void *item) const
| See if `item` is selected. More...
void | item_swap (void *a, void *b)
| Swap the items `a` and `b`. More...
const char * | item_text (void *item) const
| Returns the label text for `item`. More...
int | item_width (void *item) const
| Returns width of `item` in pixels. More...
int | lineno (void *item) const
| Returns line number corresponding to `item`, or zero if not found. More...
void | swap (FL_BLINE *a, FL_BLINE *b)
| Swap the two items `a` and `b`. More...
Protected Member Functions inherited from Fl_Browser_
void | bbox (int &X, int &Y, int &W, int &H) const
| Returns the bounding box for the interior of the list's display window, inside the scrollbars. More...
void | deleting (void *item)
| This method should be used when `item` is being deleted from the list. More...
int | displayed (void *item) const
| Returns non-zero if `item` has been scrolled to a position where it is being displayed. More...
void | draw ()
| Draws the list within the normal widget bounding box.
void * | find_item (int ypos)
| This method returns the item under mouse y position `ypos`. More...
| Fl_Browser_ (int X, int Y, int W, int H, const char *L=0)
| The constructor makes an empty browser. More...
virtual int | full_width () const
| This method may be provided by the subclass to indicate the full width of the item list, in pixels. More...
void | inserting (void *a, void *b)
| This method should be used when an item is in the process of being inserted into the list. More...
virtual int | item_quick_height (void *item) const
| This method may be provided by the subclass to return the height of the `item`, in pixels. More...
int | leftedge () const
| This method returns the X position of the left edge of the list area after adjusting for the scrollbar and border, if any. More...
void | new_list ()
| This method should be called when the list data is completely replaced or cleared. More...
void | redraw_line (void *item)
| This method should be called when the contents of `item` has changed, but not its height. More...
void | redraw_lines ()
| This method will cause the entire list to be redrawn. More...
void | replacing (void *a, void *b)
| This method should be used when item `a` is being replaced by item `b`. More...
void * | selection () const
| Returns the item currently selected, or NULL if there is no selection. More...
void | swapping (void *a, void *b)
| This method should be used when two items `a` and `b` are being swapped. More...
void * | top () const
| Returns the item that appears at the top of the list.
Protected Member Functions inherited from Fl_Group
void | draw ()
| Draws the widget. More...
void | draw_child (Fl_Widget &widget) const
| Forces a child to redraw. More...
void | draw_children ()
| Draws all children of the group. More...
void | draw_outside_label (const Fl_Widget &widget) const
| Parents normally call this to draw outside labels of child widgets.
int * | sizes ()
| Returns the internal array of widget sizes and positions. More...
void | update_child (Fl_Widget &widget) const
| Draws a child only if it needs it. More...
Protected Member Functions inherited from Fl_Widget
void | clear_flag (unsigned int c)
| Clears a flag in the flags mask.
void | draw_backdrop () const
| If FL_ALIGN_IMAGE_BACKDROP is set, the image or deimage will be drawn.
void | draw_box () const
| Draws the widget box according its box style.
void | draw_box (Fl_Boxtype t, Fl_Color c) const
| Draws a box of type t, of color c at the widget's position and size.
void | draw_box (Fl_Boxtype t, int x, int y, int w, int h, Fl_Color c) const
| Draws a box of type t, of color c at the position X,Y and size W,H.
void | draw_focus ()
| draws a focus rectangle around the widget
void | draw_focus (Fl_Boxtype t, int x, int y, int w, int h) const
| Draws a focus box for the widget at the given position and size.
void | draw_label () const
| Draws the widget's label at the defined label position. More...
void | draw_label (int, int, int, int) const
| Draws the label in an arbitrary bounding box. More...
| Fl_Widget (int x, int y, int w, int h, const char *label=0L)
| Creates a widget at the given position and size. More...
unsigned int | flags () const
| Gets the widget flags mask.
void | h (int v)
| Internal use only. More...
void | set_flag (unsigned int c)
| Sets a flag in the flags mask.
void | w (int v)
| Internal use only. More...
void | x (int v)
| Internal use only. More...
void | y (int v)
| Internal use only. More...

## Additional Inherited Members
Static Public Member Functions inherited from Fl_Group
static Fl_Group * | current ()
| Returns the currently active group. More...
static void | current (Fl_Group *g)
| Sets the current group. More...
Static Public Member Functions inherited from Fl_Widget
static void | default_callback (Fl_Widget *cb, void *d)
| The default callback for all widgets that don't set a callback. More...
static unsigned int | label_shortcut (const char *t)
| Returns the Unicode value of the '&x' shortcut in a given text. More...
static int | test_shortcut (const char *, const bool require_alt=false)
| Returns true if the given text `t` contains the entered '&x' shortcut. More...
Public Attributes inherited from Fl_Browser_
Fl_Scrollbar | hscrollbar
| Horizontal scrollbar. More...
Fl_Scrollbar | scrollbar
| Vertical scrollbar. More...
Protected Types inherited from Fl_Widget
enum | { INACTIVE = 1<<0, INVISIBLE = 1<<1, OUTPUT = 1<<2, NOBORDER = 1<<3, FORCE_POSITION = 1<<4, NON_MODAL = 1<<5, SHORTCUT_LABEL = 1<<6, CHANGED = 1<<7, OVERRIDE = 1<<8, VISIBLE_FOCUS = 1<<9, COPIED_LABEL = 1<<10, CLIP_CHILDREN = 1<<11, MENU_WINDOW = 1<<12, TOOLTIP_WINDOW = 1<<13, MODAL = 1<<14, NO_OVERLAY = 1<<15, GROUP_RELATIVE = 1<<16, COPIED_TOOLTIP = 1<<17, FULLSCREEN = 1<<18, MAC_USE_ACCENTS_MENU = 1<<19, USERFLAG3 = 1<<29, USERFLAG2 = 1<<30, USERFLAG1 = 1<<31 }
| flags possible values enumeration. More...

## Detailed Description

The Fl_Browser widget displays a scrolling list of text lines, and manages all the storage for the text.

This is not a text editor or spreadsheet! But it is useful for showing a vertical list of named objects to the user.

Each line in the browser is identified by number. The numbers start at one (this is so that zero can be reserved for "no line" in the selective browsers). Unless otherwise noted, the methods do not check to see if the passed line number is in range and legal. It must always be greater than zero and <= size().

Each line contains a null-terminated string of text and a void * data pointer. The text string is displayed, the void * pointer can be used by the callbacks to reference the object the text describes.

The base class does nothing when the user clicks on it. The subclasses Fl_Select_Browser, Fl_Hold_Browser, and Fl_Multi_Browser react to user clicks to select lines in the browser and do callbacks.

The base class Fl_Browser_ provides the scrolling and selection mechanisms of this and all the subclasses, but the dimensions and appearance of each item are determined by the subclass. You can use Fl_Browser_ to display information other than text, or text that is dynamically produced from your own data structures. If you find that loading the browser is a lot of work or is inefficient, you may want to make a subclass of Fl_Browser_.

Some common coding patterns used for working with Fl_Browser:

// How to loop through all the items in the browser
for ( int t=1; t<=browser->size(); t++ ) { // index 1 based..!
printf("item #%d, label='%s'\n", t, browser->text(t));
}

Note: If you are subclassing Fl_Browser, it's more efficient to use the protected methods item_first() and item_next(), since Fl_Browser internally uses linked lists to manage the browser's items. For more info, see find_item(int).

## Constructor & Destructor Documentation

## ◆ Fl_Browser()

Fl_Browser::Fl_Browser | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | const char * | L = `0`
| ) |  |

The constructor makes an empty browser.

Parameters

  [in] | X,Y,W,H | position and size.
  [in] | L | label string, may be NULL.

## Member Function Documentation

## ◆ _remove()

FL_BLINE * Fl_Browser::_remove | ( | int | line | ) |
| protected

Removes the item at the specified `line`.

Caveat: See efficiency note in find_line(). You must call redraw() to make any changes visible.

Parameters

  [in] | line | The line number to be removed. (1 based) Must be in range!

Returns
  Pointer to browser item that was removed (and is no longer valid).

See also
  add(), insert(), remove(), swap(int,int), clear()

## ◆ add()

void Fl_Browser::add | ( | const char * | newtext,
|  | void * | d = `0`
| ) |  |

Adds a new line to the end of the browser.

The text string `newtext` may contain format characters; see format_char() for details. `newtext` is copied using the strdup() function, and can be NULL to make a blank line.

The optional void* argument `d` will be the data() for the new item.

Parameters

  [in] | newtext | The label text used for the added item
  [in] | d | Optional user data() for the item (0 if unspecified)

See also
  add(), insert(), remove(), swap(int,int), clear()

## ◆ bottomline()

void Fl_Browser::bottomline | ( | int | line | ) |
| inline

Scrolls the browser so the bottom item in the browser is showing the specified `line`.

Parameters

  [in] | line | The line to be displayed at the bottom.

See also
  topline(), middleline(), bottomline(), displayed(), lineposition()

## ◆ clear()

void Fl_Browser::clear | ( |  | ) |

Removes all the lines in the browser.

See also
  add(), insert(), remove(), swap(int,int), clear()

## ◆ column_char() [1/2]

char Fl_Browser::column_char | ( |  | ) | const
| inline

Gets the current column separator character.

The default is '\t' (tab).

See also
  column_char(), column_widths()

## ◆ column_char() [2/2]

void Fl_Browser::column_char | ( | char | c | ) |
| inline

Sets the column separator to c.

This will only have an effect if you also set column_widths(). The default is '\t' (tab).

See also
  column_char(), column_widths()

## ◆ column_widths() [1/2]

const int* Fl_Browser::column_widths | ( |  | ) | const
| inline

Gets the current column width array.

This array is zero-terminated and specifies the widths in pixels of each column. The text is split at each column_char() and each part is formatted into it's own column. After the last column any remaining text is formatted into the space between the last column and the right edge of the browser, even if the text contains instances of column_char() . The default value is a one-element array of just a zero, which means there are no columns.

Example:

Fl_Browser *b = new Fl_Browser(..);
static int widths[] = { 50, 50, 50, 70, 70, 40, 40, 70, 70, 50, 0 }; // widths for each column
b->column_widths(widths); // assign array to widget
b->column_char('\t'); // use tab as the column character
b->add("USER\tPID\tCPU\tMEM\tVSZ\tRSS\tTTY\tSTAT\tSTART\tTIME\tCOMMAND");
b->add("root\t2888\t0.0\t0.0\t1352\t0\ttty3\tSW\tAug15\t0:00\t@b@f/sbin/mingetty tty3");
b->add("root\t13115\t0.0\t0.0\t1352\t0\ttty2\tSW\tAug30\t0:00\t@b@f/sbin/mingetty tty2");
[..]

See also
  column_char(), column_widths()

## ◆ column_widths() [2/2]

void Fl_Browser::column_widths | ( | const int * | arr | ) |
| inline

Sets the current array to `arr`.

Make sure the last entry is zero.

See also
  column_char(), column_widths()

## ◆ data() [1/2]

void * Fl_Browser::data | ( | int | line | ) | const

Returns the user data() for specified `line`.

Return value can be NULL if `line` is out of range or no user data() was defined. The parameter `line` is 1 based (1 will be the first item in the list).

Parameters

  [in] | line | The line number of the item whose data() is returned. (1 based)

Returns
  The user data pointer (can be NULL)

## ◆ data() [2/2]

void Fl_Browser::data | ( | int | line,
|  | void * | d
| ) |  |

Sets the user data for specified `line` to `d`.

Does nothing if `line` is out of range.

Parameters

  [in] | line | The line of the item whose data() is to be changed. (1 based)
  [in] | d | The new data to be assigned to the item. (can be NULL)

## ◆ display()

void Fl_Browser::display | ( | int | line,
|  | int | val = `1`
| ) |  |

For back compatibility.

This calls show(line) if `val` is true, and hide(line) otherwise. If `val` is not specified, the default is 1 (makes the line visible).

See also
  show(int), hide(int), display(), visible(), make_visible()

## ◆ displayed()

int Fl_Browser::displayed | ( | int | line | ) | const
| inline

Returns non-zero if `line` has been scrolled to a position where it is being displayed.

Checks to see if the item's vertical position is within the top and bottom edges of the display window. This does NOT take into account the hide()/show() status of the widget or item.

Parameters

  [in] | line | The line to be checked

Returns
  1 if visible, 0 if not visible.

See also
  topline(), middleline(), bottomline(), displayed(), lineposition()

## ◆ find_line()

FL_BLINE * Fl_Browser::find_line | ( | int | line | ) | const
| protected

Returns the item for specified `line`.

Note: This call is slow. It's fine for e.g. responding to user clicks, but slow if called often, such as in a tight sorting loop. Finding an item 'by line' involves a linear lookup on the internal linked list. The performance hit can be significant if the browser's contents is large, and the method is called often (e.g. during a sort). If you're writing a subclass, use the protected methods item_first(), item_next(), etc. to access the internal linked list more efficiently.

Parameters

  [in] | line | The line number of the item to return. (1 based)

Return values

  item | that was found.
  NULL | if line is out of range.

See also
  item_at(), find_line(), lineno()

## ◆ format_char() [1/2]

char Fl_Browser::format_char | ( |  | ) | const
| inline

Gets the current format code prefix character, which by default is '@'.

A string of formatting codes at the start of each column are stripped off and used to modify how the rest of the line is printed:

- `'@.'` Print rest of line, don't look for more '@' signs
- `'@@'` Print rest of line starting with '@'
- `'@l'` Use a LARGE (24 point) font
- `'@m'` Use a medium large (18 point) font
- `'@s'` Use a small (11 point) font
- `'@b'` Use a bold font (adds FL_BOLD to font)
- `'@i'` Use an italic font (adds FL_ITALIC to font)
- `'@f' or '@t'` Use a fixed-pitch font (sets font to FL_COURIER)
- `'@c'` Center the line horizontally
- `'@r'` Right-justify the text
- `'@B0', '@B1', ... '@B255'` Fill the backgound with fl_color(n)
- `'@C0', '@C1', ... '@C255'` Use fl_color(n) to draw the text
- `'@F0', '@F1', ...` Use fl_font(n) to draw the text
- `'@S1', '@S2', ...` Use point size n to draw the text
- `'@u' or '@_'` Underline the text.
- `'@-'` draw an engraved line through the middle.

Notice that the '@.' command can be used to reliably terminate the parsing. To print a random string in a random color, use `sprintf("@C%d@.%s", color, string)` and it will work even if the string starts with a digit or has the format character in it.

## ◆ format_char() [2/2]

void Fl_Browser::format_char | ( | char | c | ) |
| inline

Sets the current format code prefix character to `c`.

The default prefix is '@'. Set the prefix to 0 to disable formatting.

See also
  format_char() for list of '@' codes

## ◆ full_height()

int Fl_Browser::full_height | ( |  | ) | const
| protectedvirtual

The height of the entire list of all visible() items in pixels.

This returns the accumulated height of all the items in the browser that are not hidden with hide(), including items scrolled off screen.

Returns
  The accumulated size of all the visible items in pixels.

See also
  item_height(), item_width(),
  incr_height(), full_height()

Reimplemented from Fl_Browser_.

## ◆ hide()

void Fl_Browser::hide | ( | int | line | ) |

Makes `line` invisible, preventing selection by the user.

The line can still be selected under program control. This changes the full_height() if the state was changed. When a line is made invisible, lines below it are moved up in the display. redraw() is called automatically if a change occurred.

Parameters

  [in] | line | The line to be hidden. (1 based)

See also
  show(int), hide(int), display(), visible(), make_visible()

## ◆ icon() [1/2]

Fl_Image * Fl_Browser::icon | ( | int | line | ) | const

Returns the icon currently defined for `line`.

If no icon is defined, NULL is returned.

Parameters

  [in] | line | The line whose icon is returned.

Returns
  The icon defined, or NULL if none.

## ◆ icon() [2/2]

void Fl_Browser::icon | ( | int | line,
|  | Fl_Image * | icon
| ) |  |

Set the image icon for `line` to the value `icon`.

Caller is responsible for keeping the icon allocated. The `line` is automatically redrawn.

Parameters

  [in] | line | The line to be modified. If out of range, nothing is done.
  [in] | icon | The image icon to be assigned to the `line`. If NULL, any previous icon is removed.

## ◆ incr_height()

int Fl_Browser::incr_height | ( |  | ) | const
| protectedvirtual

The default 'average' item height (including inter-item spacing) in pixels.

This currently returns textsize() + 2.

Returns
  The value in pixels.

See also
  item_height(), item_width(),
  incr_height(), full_height()

Reimplemented from Fl_Browser_.

## ◆ insert() [1/2]

void Fl_Browser::insert | ( | int | line,
|  | const char * | newtext,
|  | void * | d = `0`
| ) |  |

Insert a new entry whose label is `newtext` above given `line`, optional data `d`.

Text may contain format characters; see format_char() for details. `newtext` is copied using the strdup() function, and can be NULL to make a blank line.

The optional void * argument `d` will be the data() of the new item.

Parameters

  [in] | line | Line position for insert. (1 based) If `line` > size(), the entry will be added at the end.
  [in] | newtext | The label text for the new line.
  [in] | d | Optional pointer to user data to be associated with the new line.

## ◆ insert() [2/2]

void Fl_Browser::insert | ( | int | line,
|  | FL_BLINE * | item
| ) |  |
| protected

Insert specified `item` above `line`.

If `line` > size() then the line is added to the end.

Caveat: See efficiency note in find_line().

Parameters

  [in] | line | The new line will be inserted above this line (1 based).
  [in] | item | The item to be added.

## ◆ item_at()

void* Fl_Browser::item_at | ( | int | line | ) | const
| inlineprotectedvirtual

Return the item at specified `line`.

Parameters

  [in] | line | The line of the item to return. (1 based)

Returns
  The item, or NULL if line out of range.

See also
  item_at(), find_line(), lineno()

Reimplemented from Fl_Browser_.

## ◆ item_draw()

void Fl_Browser::item_draw | ( | void * | item,
|  | int | X,
|  | int | Y,
|  | int | W,
|  | int | H
| ) |  | const
| protectedvirtual

Draws `item` at the position specified by `X` `Y` `W` `H`.

The `W` and `H` values are used for clipping. Should only be called within the context of an FLTK draw().

Parameters

  [in] | item | The item to be drawn
  [in] | X,Y,W,H | position and size.

Implements Fl_Browser_.

## ◆ item_first()

void * Fl_Browser::item_first | ( |  | ) | const
| protectedvirtual

Returns the very first item in the list.

Example of use:

// Walk the browser from beginning to end
for ( void *i=item_first(); i; i=item_next(i) ) {
printf("item label='%s'\n", item_text(i));
}

Returns
  The first item, or NULL if list is empty.

See also
  item_first(), item_last(), item_next(), item_prev()

Implements Fl_Browser_.

## ◆ item_height()

int Fl_Browser::item_height | ( | void * | item | ) | const
| protectedvirtual

Returns height of `item` in pixels.

This takes into account embedded @ codes within the text() label.

Parameters

  [in] | item | The item whose height is returned.

Returns
  The height of the item in pixels.

See also
  item_height(), item_width(),
  incr_height(), full_height()

Implements Fl_Browser_.

## ◆ item_last()

void * Fl_Browser::item_last | ( |  | ) | const
| protectedvirtual

Returns the very last item in the list.

Example of use:

// Walk the browser in reverse, from end to start
for ( void *i=item_last(); i; i=item_prev(i) ) {
printf("item label='%s'\n", item_text(i));
}

Returns
  The last item, or NULL if list is empty.

See also
  item_first(), item_last(), item_next(), item_prev()

Reimplemented from Fl_Browser_.

## ◆ item_next()

void * Fl_Browser::item_next | ( | void * | item | ) | const
| protectedvirtual

Returns the next item after `item`.

Parameters

  [in] | item | The 'current' item

Returns
  The next item after `item`, or NULL if there are none after this one.

See also
  item_first(), item_last(), item_next(), item_prev()

Implements Fl_Browser_.

## ◆ item_prev()

void * Fl_Browser::item_prev | ( | void * | item | ) | const
| protectedvirtual

Returns the previous item before `item`.

Parameters

  [in] | item | The 'current' item

Returns
  The previous item before `item`, or NULL if there are none before this one.

See also
  item_first(), item_last(), item_next(), item_prev()

Implements Fl_Browser_.

## ◆ item_select()

void Fl_Browser::item_select | ( | void * | item,
|  | int | val
| ) |  |
| protectedvirtual

Change the selection state of `item` to the value `val`.

Parameters

  [in] | item | The item to be changed.
  [in] | val | The new selection state: 1 selects, 0 de-selects.

See also
  select(), selected(), value(), item_select(), item_selected()

Reimplemented from Fl_Browser_.

## ◆ item_selected()

int Fl_Browser::item_selected | ( | void * | item | ) | const
| protectedvirtual

See if `item` is selected.

Parameters

  [in] | item | The item whose selection state is to be checked.

Returns
  1 if selected, 0 if not.

See also
  select(), selected(), value(), item_select(), item_selected()

Reimplemented from Fl_Browser_.

## ◆ item_swap()

void Fl_Browser::item_swap | ( | void * | a,
|  | void * | b
| ) |  |
| inlineprotectedvirtual

Swap the items `a` and `b`.

You must call redraw() to make any changes visible.

Parameters

  [in] | a,b | the items to be swapped.

See also
  swap(int,int), item_swap()

Reimplemented from Fl_Browser_.

## ◆ item_text()

const char * Fl_Browser::item_text | ( | void * | item | ) | const
| protectedvirtual

Returns the label text for `item`.

Parameters

  [in] | item | The item whose label text is returned.

Returns
  The item's text string. (Can be NULL)

Reimplemented from Fl_Browser_.

## ◆ item_width()

int Fl_Browser::item_width | ( | void * | item | ) | const
| protectedvirtual

Returns width of `item` in pixels.

This takes into account embedded @ codes within the text() label.

Parameters

  [in] | item | The item whose width is returned.

Returns
  The width of the item in pixels.

See also
  item_height(), item_width(),
  incr_height(), full_height()

Implements Fl_Browser_.

## ◆ lineno()

int Fl_Browser::lineno | ( | void * | item | ) | const
| protected

Returns line number corresponding to `item`, or zero if not found.

Caveat: See efficiency note in find_line().

Parameters

  [in] | item | The item to be found

Returns
  The line number of the item, or 0 if not found.

See also
  item_at(), find_line(), lineno()

## ◆ lineposition()

void Fl_Browser::lineposition | ( | int | line,
|  | Fl_Line_Position | pos
| ) |  |

Updates the browser so that `line` is shown at position `pos`.

Parameters

  [in] | line | line number. (1 based)
  [in] | pos | position.

See also
  topline(), middleline(), bottomline()

## ◆ load()

int Fl_Browser::load | ( | const char * | filename | ) |

Clears the browser and reads the file, adding each line from the file to the browser.

If the filename is NULL or a zero-length string then this just clears the browser. This returns zero if there was any error in opening or reading the file, in which case errno is set to the system error. The data() of each line is set to NULL.

Parameters

  [in] | filename | The filename to load

Returns
  1 if OK, 0 on error (errno has reason)

See also
  add()

## ◆ make_visible()

void Fl_Browser::make_visible | ( | int | line | ) |
| inline

Make the item at the specified `line` visible().

Functionally similar to show(int line). If `line` is out of range, redisplay top or bottom of list as appropriate.

Parameters

  [in] | line | The line to be made visible.

See also
  show(int), hide(int), display(), visible(), make_visible()

## ◆ middleline()

void Fl_Browser::middleline | ( | int | line | ) |
| inline

Scrolls the browser so the middle item in the browser is showing the specified `line`.

Parameters

  [in] | line | The line to be displayed in the middle.

See also
  topline(), middleline(), bottomline(), displayed(), lineposition()

## ◆ move()

void Fl_Browser::move | ( | int | to,
|  | int | from
| ) |  |

Line `from` is removed and reinserted at `to`.

Note: `to` is calculated after line `from` gets removed.

Parameters

  [in] | to | Destination line number (calculated after line `from` is removed)
  [in] | from | Line number of item to be moved

## ◆ remove()

void Fl_Browser::remove | ( | int | line | ) |

Remove entry for given `line` number, making the browser one line shorter.

You must call redraw() to make any changes visible.

Parameters

  [in] | line | Line to be removed. (1 based) If `line` is out of range, no action is taken.

See also
  add(), insert(), remove(), swap(int,int), clear()

## ◆ remove_icon()

void Fl_Browser::remove_icon | ( | int | line | ) |

Removes the icon for `line`.

It's ok to remove an icon if none has been defined.

Parameters

  [in] | line | The line whose icon is to be removed.

## ◆ select()

int Fl_Browser::select | ( | int | line,
|  | int | val = `1`
| ) |  |

Sets the selection state of the item at `line` to the value `val`.

If `val` is not specified, the default is 1 (selects the item).

Parameters

  [in] | line | The line number of the item to be changed. (1 based)
  [in] | val | The new selection state (1=select, 0=de-select).

Returns
  1 if the state changed, 0 if not.

See also
  select(), selected(), value(), item_select(), item_selected()

## ◆ selected()

int Fl_Browser::selected | ( | int | line | ) | const

Returns 1 if specified `line` is selected, 0 if not.

Parameters

  [in] | line | The line being checked (1 based)

Returns
  1 if item selected, 0 if not.

See also
  select(), selected(), value(), item_select(), item_selected()

## ◆ show()

void Fl_Browser::show | ( | int | line | ) |

Makes `line` visible, and available for selection by user.

Opposite of hide(int). This changes the full_height() if the state was changed. redraw() is called automatically if a change occurred.

Parameters

  [in] | line | The line to be shown. (1 based)

See also
  show(int), hide(int), display(), visible(), make_visible()

## ◆ size()

int Fl_Browser::size | ( |  | ) | const
| inline

Returns how many lines are in the browser.

The last line number is equal to this. Returns 0 if browser is empty.

## ◆ swap() [1/2]

void Fl_Browser::swap | ( | FL_BLINE * | a,
|  | FL_BLINE * | b
| ) |  |
| protected

Swap the two items `a` and `b`.

Uses swapping() to ensure list updates correctly.

Parameters

  [in] | a,b | The two items to be swapped.

See also
  swap(int,int), item_swap()

## ◆ swap() [2/2]

void Fl_Browser::swap | ( | int | a,
|  | int | b
| ) |  |

Swaps two browser lines `a` and `b`.

You must call redraw() to make any changes visible.

Parameters

  [in] | a,b | The two lines to be swapped. (both 1 based)

See also
  swap(int,int), item_swap()

## ◆ text() [1/2]

const char * Fl_Browser::text | ( | int | line | ) | const

Returns the label text for the specified `line`.

Return value can be NULL if `line` is out of range or unset. The parameter `line` is 1 based.

Parameters

  [in] | line | The line number of the item whose text is returned. (1 based)

Returns
  The text string (can be NULL)

## ◆ text() [2/2]

void Fl_Browser::text | ( | int | line,
|  | const char * | newtext
| ) |  |

Sets the text for the specified `line` to `newtext`.

Text may contain format characters; see format_char() for details. `newtext` is copied using the strdup() function, and can be NULL to make a blank line.

Does nothing if `line` is out of range.

Parameters

  [in] | line | The line of the item whose text will be changed. (1 based)
  [in] | newtext | The new string to be assigned to the item.

## ◆ textsize()

void Fl_Browser::textsize | ( | Fl_Fontsize | newSize | ) |

Sets the default text size (in pixels) for the lines in the browser to `newSize`.

This method recalculates all item heights and caches the total height internally for optimization of later item changes. This can be slow if there are many items in the browser.

It returns immediately (w/o recalculation) if `newSize` equals the current textsize().

You may need to call redraw() to see the effect and to have the scrollbar positions recalculated.

You should set the text size before populating the browser with items unless you really need to change the size later.

## ◆ topline() [1/2]

int Fl_Browser::topline | ( |  | ) | const

Returns the line that is currently visible at the top of the browser.

If there is no vertical scrollbar then this will always return 1.

Returns
  The lineno() of the top() of the browser.

## ◆ topline() [2/2]

void Fl_Browser::topline | ( | int | line | ) |
| inline

Scrolls the browser so the top item in the browser is showing the specified `line`.

Parameters

  [in] | line | The line to be displayed at the top.

See also
  topline(), middleline(), bottomline(), displayed(), lineposition()

## ◆ value() [1/2]

int Fl_Browser::value | ( |  | ) | const

Returns the line number of the currently selected line, or 0 if none selected.

Returns
  The line number of current selection, or 0 if none selected.

See also
  select(), selected(), value(), item_select(), item_selected()

## ◆ value() [2/2]

void Fl_Browser::value | ( | int | line | ) |
| inline

Sets the browser's value(), which selects the specified `line`.

This is the same as calling select(line).

See also
  select(), selected(), value(), item_select(), item_selected()

## ◆ visible()

int Fl_Browser::visible | ( | int | line | ) | const

Returns non-zero if the specified `line` is visible, 0 if hidden.

Use show(int), hide(int), or make_visible(int) to change an item's visible state.

Parameters

  [in] | line | The line in the browser to be tested. (1 based)

See also
  show(int), hide(int), display(), visible(), make_visible()

The documentation for this class was generated from the following files:

- Fl_Browser.H
- Fl_Browser.cxx
- Fl_Browser_load.cxx

Fl_Browser::Fl_Browser
Fl_Browser(int X, int Y, int W, int H, const char *L=0)
The constructor makes an empty browser.
Definition: Fl_Browser.cxx:603
Fl_Browser
The Fl_Browser widget displays a scrolling list of text lines, and manages all the storage for the te...
Definition: Fl_Browser.H:80
Fl_Browser::item_next
void * item_next(void *item) const
Returns the next item after item.
Definition: Fl_Browser.cxx:78
Fl_Browser::item_last
void * item_last() const
Returns the very last item in the list.
Definition: Fl_Browser.cxx:100
Fl_Browser::item_prev
void * item_prev(void *item) const
Returns the previous item before item.
Definition: Fl_Browser.cxx:86
Fl_Browser::item_first
void * item_first() const
Returns the very first item in the list.
Definition: Fl_Browser.cxx:70
Fl_Browser::item_text
const char * item_text(void *item) const
Returns the label text for item.
Definition: Fl_Browser.cxx:127
- © 1998-2016 by Bill Spitzak and others.